> For the complete documentation index, see [llms.txt](https://docs.fortmatic.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fortmatic.com/web3-integration/sdk-error-handling.md).

# SDK Error Handling

For logging in, signing data, or sending transactions, users can deny by simply closing the modal. On these events, Fortmatic SDK will throw an error to indicate that user has denied one of those actions.

## Logging In

```javascript
import Fortmatic from 'fortmatic';
import Web3 from 'web3';

const fm = new Fortmatic('YOUR_API_KEY');
window.web3 = new Web3(fm.getProvider());

try {
  const accounts = await web3.eth.getAccounts();

  // other functions for logging in:
  // const accounts = await web3.currentProvider.enable();
  // const accounts = await fm.user.login();
}
catch (err) { // if user closes the modal without logging in
  console.log(err); // { message: 'Fortmatic: User denied account access.', code: '4001' }
}
```

## Sending a Transaction

```javascript
import Fortmatic from 'fortmatic';
import Web3 from 'web3';

const fm = new Fortmatic('YOUR_API_KEY');
window.web3 = new Web3(fm.getProvider());

try {
  web3.eth.sendTransaction(...);
}
catch (err) { // if user closes the modal without starting the transaction
  console.log(err); // { message: 'Fortmatic: User denied transaction.', code: '-32603' }
}
```

## Signing a Data

```javascript
import Fortmatic from 'fortmatic';
import Web3 from 'web3';

const fm = new Fortmatic('YOUR_API_KEY');
window.web3 = new Web3(fm.getProvider());

try {
  await web3.currentProvider.sendAsync(
  {
    id: 1,
    method: 'eth_signTypedData', // other function for signing: personal_sign
    params: [...]
  });
}
catch (err) { // if user closes the modal without signing
  console.log(err); // { message: 'Fortmatic: User denied transaction.', code: '-32603' }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fortmatic.com/web3-integration/sdk-error-handling.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
